#include "license-base.h"



int get_license_ukeyflag(cs2c_license_feedback *feedback, int *ukey_flag)
{
        if(feedback->ifukey==1)
        {
                *ukey_flag = 1;
                return CS2C_LICENSE_OK;
        }

        *ukey_flag = 0;
	return CS2C_LICENSE_OK;
}



int get_license_tryflag(cs2c_license_control_info *control_info, int product_number, int *try_flag)
{
        int i = 0;

        cs2c_license_control_info *control = control_info;
        for(i=0;i<product_number;i++)
        {
                if(control->iftry == 0)
                {
		        *try_flag = 0;
			return 0;
		}
                control+=1;
        }

        *try_flag = 1;

        return 0;
}






int print_license_err(int rv)
{
	switch(rv)
	{
		case CS2C_LICENSE_OK:
			printf("operating success.\n");
			break;			

		case CS2C_LICENSE_PARA_ERR:
			printf("parameter error.\n");
			break;

		case CS2C_LICENSE_NO_USBKEY:
			printf("no usbkey which should be pluged in.\n");
			break;

		case CS2C_LICENSE_BUF_SMALL:
			printf("buffer is too small.\n");
			break;

		case CS2C_LICENSE_FEEDBACK_ERR:
			printf("feedback format wrong.\n");						
			break;

		case CS2C_LICENSE_SIG_ERR:
			printf("signature wrong.\n");
			break;

		case CS2c_LICENSE_MORE_USBKEY:
			printf("more than 1 ukey plugin.\n");
			break;

		case CS2C_LICENSE_USBKEY_NOLICENSE:
			printf("ukey is plugin but no license.\n");
			break;

		case CS2C_LICENSE_USBKEY_PKCSERR:
			printf("general pkcs11 error.\n");
			break;

		case CS2C_LICENSE_NO_PRIVATE_KEY:
			printf("no license private key.\n");
			break;
		
		case CS2C_LICENSE_NO_CERT:
			printf("no license cert.\n");
			break;

		case CS2C_LICENSE_OPENSSL_ERR:
			printf("general openssl error.\n");
			break;

		case CS2C_LICENSE_RSA_VERIFY_FAILED:
			printf("rsa verify failed.\n");
			break;

		case CS2C_LICENSE_RSA_SIGN_FAILED:
			printf("rsa sign failed.\n");
			break;

		case CS2C_LICENSE_LICENSE_INFO_ERR:
			printf("license info error.\n");
			break;

		case CS2C_LICENSE_STRUCT_ERR:
			printf("icense struct is wrong:iftry,feedback must be null.\n");
			break;

		case CS2C_LICENSE_FILE_ERR:
			printf("general file operation error.\n");
			break;
/*
		case CS2C_LICENSE_FEEDBACK_ERR:
			printf("feedback format wrong.\n");
			break;
*/
		case CS2C_LICENSE_FEEDBACK_GEN_ERR:
			printf("feedback generate error.\n");
			break;

		case CS2C_LICENSE_IS_EXPIRED:
			printf("license is expired!\n");
			break;

		case CS2C_LICENSE_NO_PID:
			printf("license file doesn't contain the infomation of pid.\n");
			break;

		case CS2C_LICENSE_NEED_INSTALL:
			printf("license file needs to be installed.\n");
			break;

		case CS2C_LICENSE_DOUBLE_INSTALLED:
			printf("license file is installed more than once.\n");
			break;

		case CS2C_LICENSE_INVALID_FILE:
			printf("license file is invalid.\n");
			break;

		case CS2C_LICENSE_MIPS_NO_UKEY:
			printf("loongson platform don't support ukey.\n");
			break;

		case CS2C_LICENSE_PROC_READERR	:
			printf("can not read /proc/net/dev.\n");
			break;

		case CS2C_LICENSE_SOCKETERR	:
			printf("can not get socket AF_INET.\n");
			break;
	
		case CS2C_LICENSE_NO_USEFUL_NIC :
			printf("no useful net interface.\n");
			break;

	}

	return 0;
}
int base64(u8 *in, u32 ilen, u8 *out, u32 *olen) 
{
        int i = 0, j = 0, k = 0 ;
        u8 EncodeBase64Map[] = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";

        i = (ilen+2) / 3 * 4 ; 

        k = ilen - ilen % 3 ;
        for(i=j=0; i<k; i+=3) 
        {
                out[j++] = EncodeBase64Map[(in[i]>>2)&0x3F] ;
                out[j++] = EncodeBase64Map[((in[i]<<4) + (in[i+1]>>4))&0x3F] ;
                out[j++] = EncodeBase64Map[((in[i+1]<<2) + (in[i+2]>>6))&0x3F] ;
                out[j++] = EncodeBase64Map[in[i+2]&0x3F] ;
        }
        k = ilen - k ;
        if(1 == k)
        {
                out[j++] = EncodeBase64Map[(in[i]>>2)&0x3F] ;
                out[j++] = EncodeBase64Map[(in[i]<<4)&0x3F] ;
                out[j++] = out[j] = '=' ;
        }
        else if(2 == k)
        {
                out[j++] = EncodeBase64Map[(in[i]>>2)&0x3F] ;
                out[j++] = EncodeBase64Map[((in[i]<<4) + (in[i+1]>>4))&0x3F] ;
                out[j++] = EncodeBase64Map[(in[i+1]<<2)&0x3F] ;
                out[j] = '=' ;
        }

        *olen=++j;

	return 0;
}



int debase64(u8 *in, u32 ilen,u8 *out, u32 *olen)
{
        int i = 0, j = 0 ;
        u8 EncodeBase64Map[] = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
        u8 DecodeBase64Map[256] = {0} ;

        for(j = ilen; j>0 && '='==in[j-1]; --j) ; 
        i = (j/4)*3+(j%4+1)/2; 

        if(out != NULL)
        {

                *olen = i ;
        }
        else
        {
                *olen = i ;
        }

        j = sizeof(EncodeBase64Map) ;
        for(i=0; i<j; ++i)
                DecodeBase64Map[ EncodeBase64Map[i] ] = i ;
        for(i=j=0; i<ilen; i+=4)
        {
                out[j] = DecodeBase64Map[in[i  ]] << 2 | DecodeBase64Map[in[i+1]] >> 4 ;
                j++;
                out[j] = DecodeBase64Map[in[i+1]] << 4 | DecodeBase64Map[in[i+2]] >> 2 ;
                j++;
                out[j] = DecodeBase64Map[in[i+2]] << 6 | DecodeBase64Map[in[i+3]] ;
                j++;
        }

	return 0;
}


int print_license_control_info(cs2c_license_control_info *control_info)
{

	int i = 0;
	cs2c_license_control_info *tmp;
	tmp = control_info;

	printf("pid = %d\n",tmp->pid);
	printf("vid = %d\n",tmp->vid);
	printf("user_num = %d\n",tmp->user_num);
	printf("node_num = %d\n",tmp->node_num);
	printf("iftry = %d\n",tmp->iftry);
	printf("days = %d\n",tmp->days);
	printf("installed = %s\n",tmp->installed);
	printf("----------------------------\n");
	
	return 0;
}


int print_license_feedback(cs2c_license_feedback *fb)
{
        printf("customer = %s\n",fb->customer);
        printf("feedback = %s\n",fb->feedback);
        printf("expand = %s\n",fb->expand);
}

int print_license(cs2c_license *license)
{
        int i = 0;
	int clen = sizeof(cs2c_license_control_info);
	cs2c_license_control_info *control;

	control = license->control_info;

        printf("license->header->header_length = %d\n",license->header->header_length);
        printf("license->header->control_info_length = %d\n",license->header->control_info_length);
        printf("license->header->feedback_length = %d\n",license->header->header_length);
        printf("license->header->verify_length = %d\n",license->header->verify_length);

	for(i=0;i<license->header->control_info_length/clen;i++)
	{
		print_license_control_info(control);
		control+=1;
	}

	print_license_feedback(license->feedback);

        printf("license->signature->length = %d\n",license->signature->length);
        printf("license->signature->sig = ");
        for(i=0;i<license->signature->length;i++)
                printf("%02x",license->signature->sig[i]);
        printf("\n");
}


int free_license_struct(cs2c_license *license)
{

        if(license == NULL)
                return 0;

        if(license->header)
                free(license->header);

        if(license->control_info)
        {
		free(license->control_info);
	}

	if(license->feedback)
	{
		free(license->feedback);
	}
        if(license->signature)
        {
                free(license->signature->sig);
                free(license->signature);
        }
	free(license);
        return 0;
}

int get_lib_version(char *v, int *len)
{

	if(*len < 10)
		return CS2C_LICENSE_BUF_SMALL;

	strcpy(v,CS2C_LICENSE_LIB_VERSION);
	*len = strlen(CS2C_LICENSE_LIB_VERSION);

	return 0;
}
