#include "license-client.h"

typedef struct print_flag
{
	int pid;
	int pid_flag;
	int vid_flag;
	int user_num_flag;
	int node_num_flag;
	int mod_flag;
	int day_flag;
	int try_flag;
	int key_flag;
	int install_flag;
	int customer_flag;
	int feedback_flag;
	int expand_flag;
} PFLAG;

extern char *optarg;

static void usage()
{
        printf("Usage:\n");
        printf("1.license-ver -h \n");
        printf("        Print help. \n");
        printf("2.license-ver -f  \n");
        printf("        print feedback from MAC. \n");
#ifndef	LOONGSON_PLATFORM
        printf("3.license-ver -s \n");
        printf("        print feedback from usbkey. \n");
#else
	printf("platform can not use ukey to generate feedback!\n");
#endif
        printf("4.license-ver -d \n");
        printf("        print feedback from disk. \n");
        printf("5.license-ver -v <license.dat> -P pid -p apvunmdtcfe\n");
        printf("        verify license.dat by signature and feedback,print license with args. \n");
#ifndef	LOONGSON_PLATFORM
        printf("6.license-ver -k -P pid -p apvunmdtkcfe\n");
        printf("        verify license ukey. and print license. \n");
#else
	printf("platform can not use ukey to verify license!\n");
#endif
        /*printf("7.license-ver -i license.dat -P pid\n");
        printf("        install license.dat of pid. \n");*/
        printf("7.license-ver -c license.dat -P pid\n");
        printf("        check license.dat of pid if expired. \n");
	printf("   printf options:\n"); 
	printf("	a print all information of license\n");
	printf("	p print product ID\n");
	printf("	v print version ID\n");
	printf("	u print user number\n");
	printf("	n print node number\n");
	printf("	m print modules info\n");
	printf("	d print days\n");
	printf("	t print iftry\n");
	printf("	k print ifukey\n");
	printf("	c print customer\n");
	printf("	f print feedback\n");
	printf("	e ptint expand\n");

	//printf("9.license-ver -V\n");
	//printf("	printf the version of license lib.\n");
}


int print_feedback(int flag)
{
	u8 feedback[34];
	int length = 34;
	int i = 0;
	int rv = 0;
	
#ifdef	LOONGSON_PLATFORM
	if(flag == 1)
		return CS2C_LICENSE_MIPS_NO_UKEY;
#endif
	memset(feedback,0,34);
	rv = license_gen_feedback(feedback, &length, flag);
	if(rv == 0){
		printf("feedback for license: ");	
		for(i=0;i<length;i++)
			printf("%c",feedback[i]);
		printf("\n");
		printf("Please send this string to cs2c to get license.dat\n");

		if(feedback[0]=='0')
			printf("feedback media:MAC\n");
		else if(feedback[0]=='1')
			printf("feedback media:UKEY\n");
		else if(feedback[0]=='2')
			printf("feedback media:DISK\n");
		else
			printf("feedback type wrong!\n");


	}else{
		printf("generating feedback failed!\n");
		print_license_err(rv);
	}

        return 0;
}

int print_license_info(cs2c_license_control_info *control_info, int pnum, cs2c_license_feedback *fb, PFLAG flag)
{

	cs2c_license_control_info *tmp;
	int pid = flag.pid;
	int i = 0;
	int getit = 0;
	
	tmp = control_info;
	for(i=0;i<pnum;i++){
		if(tmp->pid == pid)
		{
			getit = 1;
			break;
		}
		tmp++;
	}
	
	if(getit == 0) tmp = NULL;

	if(getit == 0 && pid != 255){
		printf("can not get pid=%d information for license.dat\n",pid);
		return -1;
	}

	if(pid == 255)
	{
		for(i=0;i<pnum;i++){

			if(flag.pid_flag == 1)	
				printf("Product ID:%d\n", tmp->pid);
			if(flag.vid_flag == 1)	
				printf("Version ID:%d\n",tmp->vid);
			if(flag.user_num_flag == 1)	
				printf("User Number:%d\n",tmp->user_num);
			if(flag.node_num_flag == 1)	
				printf("Node Number:%d\n",tmp->node_num);
			if(flag.mod_flag == 1)	
				printf("Modules:%u\n",tmp->modules);
			if(flag.day_flag == 1)	
				printf("Days:%d\n",tmp->days);
			if(flag.try_flag == 1)	
				printf("Iftry:%d\n",tmp->iftry);
                        if(flag.install_flag == 1)
                                printf("Install Date:%s\n",tmp->installed);
		}

		tmp++;
	}else{
                        if(flag.pid_flag == 1)
                                printf("Product ID:%d\n", tmp->pid);
                        if(flag.vid_flag == 1)
                                printf("Version ID:%d\n",tmp->vid);
                        if(flag.user_num_flag == 1)
                                printf("User Number:%d\n",tmp->user_num);
                        if(flag.node_num_flag == 1)
                                printf("Node Number:%d\n",tmp->node_num);
                        if(flag.mod_flag == 1)
                                printf("Modules:%u\n",tmp->modules);
                        if(flag.day_flag == 1)
                                printf("Days:%d\n",tmp->days);
                        if(flag.try_flag == 1)
                                printf("Iftry:%d\n",tmp->iftry);
                        if(flag.install_flag == 1)
                                printf("Install Date:%s\n",tmp->installed);
	}

	if(flag.customer_flag == 1)	
		printf("Customer Info:%s\n",fb->customer);
	if(flag.feedback_flag == 1)	
		printf("Feedback:%s\n",fb->feedback);
	if(flag.expand_flag == 1)	
		printf("Extension Info:%s\n",fb->expand);

	return 0;
}



int verify_license(char *path, PFLAG flag)
{
	int rv = 0;
	int pnum = 0;
	
	cs2c_license_control_info control_info[32];
	cs2c_license_feedback fb;
	
	memset(&control_info,0,32*sizeof(cs2c_license_control_info));
	//rv = license_verify(path,(cs2c_license_control_info *)&control_info,&pnum,&fb);
	int mt_chflag = 0;
	rv = license_verify_v2(path,(cs2c_license_control_info *)&control_info,&pnum,&fb, flag.pid, &mt_chflag);
	if(rv == 0)
	{
		printf("license verify succeed!\n");
		//print_license_control_info(&control_info);
		print_license_info((cs2c_license_control_info *)&control_info,pnum,&fb,flag);
	}else{
		printf("license verify failed!\n");
		if(rv == CS2C_LICENSE_NO_PID)
			printf("can not get pid=%d information for license.dat\n",flag.pid);
		else
			print_license_err(rv);
	}
	return 0;
}


int setup_pid(int *pid,char *pidstring)
{
	int i = 0;
	int len = 0;

	len =strlen(pidstring);
	*pid = 0;

	printf("len=%d\n",len);
	if(len>3){
		printf("pid is wrong!pid>=0 && pid<=255,len=%d\n",len);
		exit(0);
	}

	
	while(*(pidstring+i)!=0 && i<3)
	{
		if(i==0)
		{
			*pid = *pidstring-0x30;
			int j = len -i -1;
			while(j>0)
			{
				*pid=10*(*pid);
				j--;

			}
		} else {
			int tmp = *(pidstring+i)-0x30;
			int j = len - i -i;
			while(j>0)
			{
				tmp=10*tmp;
				j--;
			}

			*pid+=tmp;
		}

		i++;
	}

	if(*pid>255){
		printf("pid is wrong!pid>=0 && pid<=255,pid=%d\n",*pid);
		exit(0);
	}

	return 0;	
}

int setup_pid_flag(PFLAG *flag, int pid)
{
	flag->pid = pid;

	return 0;
}

int setup_flag(PFLAG *flag, char *opt)
{
	int len = 0;
	int i = 0;

	len = strlen(opt);	

	for(i=0;i<len;i++)
	{
		switch(*opt)
		{

			case 'a':
				flag->pid_flag = 1;
				flag->vid_flag = 1;
				flag->user_num_flag = 1;
				flag->node_num_flag = 1;
				flag->mod_flag = 1;
				flag->day_flag = 1;
				flag->try_flag = 1;
				flag->install_flag = 1;
				flag->customer_flag = 1;
				flag->feedback_flag = 1;
				flag->expand_flag = 1;
				break;
			case 'p':
				flag->pid_flag = 1;
				break;

			case 'v':
				flag->vid_flag = 1;
				break;

			case 'u':
				flag->user_num_flag = 1;
				break;

			case 'n':
				flag->node_num_flag = 1;
				break;

			case 'm':
				flag->mod_flag = 1;
				break;

			case 'd':
				flag->day_flag = 1;
				break;

			case 't':
				flag->try_flag = 1;
				break;

			case 'c':
				flag->customer_flag = 1;
				break;

			case 'f':
				flag->feedback_flag = 1;
				break;

			case 'e':
				flag->expand_flag = 1;
				break;
			default:
				usage();
				break;
		}

		opt++;
	}		

	return 0;
}

/*int install_license(char *license_file,int pid)
{
	int rv = 0;
	rv = license_install(license_file,pid);	

	if(rv!=0)
	{
		if(rv == CS2C_LICENSE_NO_PID)
			printf("can not get pid=%d information for license.dat\n",pid);
		else
			print_license_err(rv);
		printf("license install failed!\n");
	} else
		printf("install license succeed!\n");

	return 0;
}*/

int get_ifexpired(char *license_file,int pid)
{

	int rv = 0;
	int expired = 0;
	rv = license_get_ifexpired(license_file,pid,&expired);
	if(rv!=0)
		print_license_err(rv);
	else if(expired==0)
		printf("license is not expired!\n");
	else
		printf("license is expired!\n");
	return 0;

} 


int check_num_string(char *string)
{
	int len = 0;
	int i = 0;

	char *p = string;
	len = strlen(string);

	if(len > 3)
	{
		printf("pid is wrong!0<=pid<=255,but %s is input.\n",string);
                exit(0);
	}
	
	for(i=0;i<len;i++)
	{
		if(*p<48 || *p>57)
			return 1;
		p++;
	}

	return 0;
}



int main(int argc, char *argv[])
{
	int opt;
	PFLAG flag;
	int pid = 999;
	int key_flag = 0;
	int verify_flag = 0;
	int check_flag = 0;
	int install_flag = 0;
	int help_flag = 99;
	int feedback_flag = 99;
	char v[16];
	int vlen = 16;
	
	char license_file[256];
	char pidstring[4];
	int rv = 0;

	
	memset(pidstring,0,4);
	memset(v,0,16);

	if(argc<2)
	{
		usage();
		return -1;
	}

	memset(license_file,0,256);
	memset(&flag,0,sizeof(flag));
	setup_pid_flag(&flag,255);

	if(argv[1][0]!='-')
	{
		usage();
		return -1;
	}

	if(argv[argc-1][0]!='-')
	{
		usage();
		return -1;
	}

        while ((opt = getopt(argc, argv, "hfsd:v:kp:P:c:")) != -1)
        {
                switch(opt) {
                        case '?':
                        case 'h':
                                help_flag = 1;
                                break;
			case 'P':
				if(check_num_string(optarg))
				{
					printf("please input a decimal number!\n");
					return -1;
				}

				pid=(u32)atoi(optarg);
				if(pid>255)
				{
					printf("pid is wrong!0<=pid<=255,but %s is input.\n",optarg);
					exit(0);
				}
				setup_pid_flag(&flag,pid);
				break;
			case 'p':
				setup_flag(&flag,optarg);
				break;
                        case 'f':
				if(feedback_flag==1 || feedback_flag==2)
				{
					printf("you can't use more than 1 feedback once!\n");
					return -1;
				}
				feedback_flag=0;
				break;
                        case 's':
				if(feedback_flag==0 || feedback_flag==2)
				{
					printf("you can't use more than 1 feedback once!\n");
					return -1;
				}
				feedback_flag=1;
				break;
                        case 'd':
				if(feedback_flag==0 || feedback_flag==1)
				{
					printf("you can't use more than 1 feedback once!\n");
					return -1;
				}
				feedback_flag=2;
				break;
                        /*case 'i':
				install_flag = 1;
				if(optarg==NULL)
					key_flag = 1;
				else
					strcpy(license_file,optarg);	
                                break;*/
                        case 'c':
				check_flag = 1;

				if(strlen(optarg)>256)
				{
					printf("too lang license.dat path.");
					return -1;
				}
				
				if(optarg==NULL)
					key_flag = 1;
				else
					strcpy(license_file,optarg);	
				break;
			case 'v':
				verify_flag = 1;
				if(strlen(optarg)>256)
				{
					printf("too lang license.dat path.");
					return -1;
				}

				if(optarg==NULL)
					key_flag = 1;
				else
					strcpy(license_file,optarg);
				break;	
			case 'k':
				verify_flag = 1;
				key_flag = 1;
				break;
			/*case 'V':
				license_get_lib_version(v,&vlen);
				printf("%s\n",v);
				exit(0);*/
                        default:
				help_flag=1;
                                break;
                }

        }

	if(help_flag==1)
	{
		usage();
		return 0;
	}

	if(feedback_flag!=99)
	{
		//print_feedback(feedback_flag);
		printf("This tool not support. Please Use command \'nklicadm -g\' to generate feedback.\n");
		return 0;
	}

	if(verify_flag && check_flag && install_flag)
	{
		printf("you can not do verify,check,install in one time!\n");
		return 0;
	}

	if(verify_flag == 1)
	{
        	if(pid==999)
        	{
                	printf("Please input a pid with -P!\n");
                        return -1;
                }

		if(key_flag == 0)
			rv = verify_license(license_file,flag);
		if(key_flag == 1)
			rv = verify_license(NULL,flag);
		return 0;
	}
		
	if(check_flag == 1)
	{
		if(pid==999)
		{
			printf("Please input a pid with -P!\n");
			return -1;
		}

		if(key_flag == 0)
			rv = get_ifexpired(license_file,pid);
		if(key_flag == 1)
			rv = get_ifexpired(NULL,pid);
		return 0;
	}	

	/*if(install_flag ==1)
	{
		if(pid==999)
		{
			printf("Please input a pid with -P!\n");
			return -1;
		}

		if(key_flag == 0)
			rv = install_license(license_file,pid);
		if(key_flag == 1)
			rv = install_license(NULL,pid);

		return 0;
	}*/

	return 0;
}
